// 002 u_iso_cd_extractor
// 27 sep 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_iso_cd_extractor;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
        Menus, ExtCtrls, ComCtrls, StdCtrls, FileCtrl
        ;

    type TForm1= class(TForm)
                   PageControl1: TPageControl;
                   display_: TTabSheet;
                   directory_: TTabSheet;
                   Panel1: TPanel;
                   clear_: TButton;
                   exit_: TButton;
                   DirectoryListBox1: TDirectoryListBox;
                   FileListBox1: TFileListBox;
                   display_iso_path_file_: TButton;
                   Memo1: TMemo;
                   directory_tree_view: TTreeView;
                   build_tree_view_: TButton;
                   extract_iso_: TButton;
                   procedure FormCreate(Sender: TObject);
                   procedure FormDestroy(Sender: TObject);
                   procedure exit_Click(Sender: TObject);
                   procedure clear_Click(Sender: TObject);
                   procedure DirectoryListBox1Change(Sender: TObject);
                   procedure FileListBox1Click(Sender: TObject);
                   procedure display_iso_path_file_Click(Sender: TObject);
                   procedure build_tree_view_Click(Sender: TObject);
                   procedure extract_iso_Click(Sender: TObject);
                   private
                   public
                 end;

    var Form1: TForm1;

  implementation
    uses u_c_display, u_c_log, u_dir, u_strings
        , u_iso_definitions
        , u_c_iso_path_and_file
        , u_c_analyze_iso_file
        ;

    {$R *.DFM}

   
    const k_initial_directory= '..\programs\iso_cd_extractor\_data\';
            k_extension= '.iso';
            k_file_name= 'pascal.iso';
          k_save_path= '..\programs\iso_cd_extractor\_save\';

    var g_path: string= k_initial_directory;
        g_file_name: string= k_file_name;

        g_c_analyze_iso_file: c_analyze_iso_file= Nil;
        g_c_iso_path_and_file: c_iso_path= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: string;
          p_pt_data: Pointer);
        // -- builds the path and file trees
      begin
        with form1 do
        begin
          clear_display;

          g_c_iso_path_and_file:= c_iso_path.create_iso_path('', '', Nil);

          g_c_analyze_iso_file:= c_analyze_iso_file.create_analyze_iso_file(p_path+ p_file_name);
          try
            g_c_analyze_iso_file.f_open_iso_file(g_c_iso_path_and_file);
          except
            display('Exception: '+ Exception(ExceptObject).
                ClassName+ ' -> '+ Exception(ExceptObject).message);
            raise;
          end;
        end;
      end; // my_call_back

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_directory_listbox_directory(DirectoryListBox1, k_initial_directory);
        // set_directory_listbox_directory(DirectoryListBox1, k_save_path);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        display_path_and_file;
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      var l_path, l_name: string;
      begin
        l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          l_name:= Items[ItemIndex];
        my_call_back(0, l_path+ '\', l_name, nil);
      end; // FileListBox1Click

    // -- close

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        close;
      end; // exit_Click

    procedure TForm1.display_iso_path_file_Click(Sender: TObject);
      begin
        g_c_iso_path_and_file.display_path_and_file;
      end; // display_iso_path_file_Click

    procedure TForm1.build_tree_view_Click(Sender: TObject);

      procedure build_tree_recursive(p_c_tree_view: TTreeView; p_c_parent_node: TTreeNode;
          p_c_iso_path: c_iso_path);
        var l_file_index: Integer;
            l_c_file_node: tTreeNode;
            l_c_path_node: tTreeNode;

            l_sub_path_index: Integer;
        begin
          with p_c_iso_path do
          begin
            for l_sub_path_index:= 0 to f_sub_path_count- 1 do
              with f_c_sub_path(l_sub_path_index) do
              begin
                l_c_path_node:= p_c_tree_view.Items.AddChild(p_c_parent_node, m_name);
                l_c_path_node.Data:= Pointer(f_c_self);

                // -- recurse
                build_tree_recursive(p_c_tree_view, l_c_path_node, f_c_self);
              end;

            for l_file_index:= 0 to f_file_count- 1 do
              with f_c_file(l_file_index) do
              begin
                l_c_file_node:= p_c_tree_view.Items.AddChild(p_c_parent_node, m_name);
                l_c_file_node.Data:= Pointer(f_c_self);
              end;
          end; // with p_c_path
        end; // build_tree_recursive

      var l_c_root_node: TTreeNode;

      begin // build_tree_view_Click
        directory_tree_view.Items.Clear;

        l_c_root_node:= directory_tree_view.Items.Add(nil, '/');
        l_c_root_node.Data:= g_c_iso_path_and_file;
        build_tree_recursive(directory_tree_view, l_c_root_node, g_c_iso_path_and_file);
      end; // build_tree_view_Click

    procedure TForm1.extract_iso_Click(Sender: TObject);
      var l_count, l_count_max: Integer;

      procedure extract_recursive(p_level: Integer; p_c_iso_path: c_iso_path);
        var l_file_index: Integer;
            l_sub_path_index: Integer;
        begin
          if (l_count_max> 0) and (l_count> l_count_max)
            then Exit;

          with p_c_iso_path do
          begin
            for l_file_index:= 0 to f_file_count- 1 do
              with f_c_file(l_file_index) do
              begin
                display(IntToStr(l_count)+ f_spaces(p_level)+ ' '+ p_c_iso_path.m_name+ m_name);

                g_c_analyze_iso_file.f_extract_file(f_c_self,
                    k_save_path+ '_\'+ p_c_iso_path.m_name+ m_name);
                Inc(l_count);
              end;

            // -- recurse
            for l_sub_path_index:= 0 to f_sub_path_count- 1 do
              extract_recursive(p_level+ 1, f_c_sub_path(l_sub_path_index));
          end; // with p_c_path
        end; // extract_recursive

      begin // check_with_disc_Click
        l_count_max:= -1;
        l_count:= 0;
        extract_recursive(0, g_c_iso_path_and_file);
      end; // extract_iso_Click

    procedure TForm1.FormDestroy(Sender: TObject);
      begin
        if (Assigned(g_c_analyze_iso_file))
          then FreeAndNil(g_c_analyze_iso_file);
      end; // FormDestroy

end.
